<?php
/**
 * Copyright © 2015 FiloBlu . All rights reserved.
 */

namespace FiloBlu\FreeShippingOrderInfo\Helper;

/**
 * Class Data
 * @package FiloBlu\FreeShippingOrderInfo\Helper
 */
class Data extends \Magento\Framework\App\Helper\AbstractHelper
{
    /**
     * @var string
     */
    const CONFIG_GENERAL_MODES = 'filoblu_freeshippinginfo/general/mode';

    /**
     * @var \Magento\Framework\App\Helper\Contex
     */
    protected $_context;

    /**
     * @var Modes\Data
     */
    protected $_data;

    /**
     * Data constructor.
     * @param \Magento\Framework\App\Helper\Context $context
     * @param \FiloBlu\FreeShippingOrderInfo\Model\Config\Source\Modes $data
     */
    public function __construct(\Magento\Framework\App\Helper\Context $context,
                                \FiloBlu\FreeShippingOrderInfo\Model\Config\Source\Modes $data)
    {
        $this->_context = $context;
        $this->_data = $data;
        parent::__construct($context);
    }

    /**
     * @return string
     */
    public function getGeneralMode()
    {
        $scope = $this->_context->getScopeConfig();
        $mode = $scope->getValue(self::CONFIG_GENERAL_MODES, \Magento\Store\Model\ScopeInterface::SCOPE_STORE);

        if(array_key_exists($mode, $this->_data->toArray()))
        {
            return $mode;
        }

        return \FiloBlu\FreeShippingOrderInfo\Model\Config\Source\Modes::COUPON_ONLY;
    }
}